from GGI.const  import flagAsync, emKeyPress
from GGI.ggi    import Visual
from GGI.ggift2 import putGlyphs, putGlyph
from GGI.exception import Timeout

import GGI.ft2 as ft2
import GGI._ggift2module as ggift2

import sys

if len(sys.argv)!=2:
    print "usage :%s <fontfile>"%sys.argv[0]
    sys.exit()

def wait(vis, timeout = None):
    vis.flush()
    try:
        if timeout:
            vis.poll(timeout = timeout, mask = emKeyPress)
        else:
            vis.poll(mask = emKeyPress)
    except:
        return None
    return vis.read(emKeyPress)

def box(vis,x,y,w,h):
    vis.putHLine(x,y,w)
    vis.putHLine(x,y+h-1,w)
    vis.putVLine(x,y,h)
    vis.putVLine(x+w-1,y,h)

# get a visual
v       = Visual()
v.mode  = v.Mode()
size    = v.mode.visible
v.flags = flagAsync
fx,fy   = v.charSize

f = ft2.Library().Face(sys.argv[1])

f.setPixelSizes(50,50)
v.putBox(30,30,200,160,[1,0,0])
v.putBox(130,80,200,160,[0,1,0])
v.putBox(80,130,200,160,[0,0,1])

putGlyphs(v, f, 20, size[1]/3, "This is a GGI Freetype test!", (1,1,1,1))
putGlyphs(v, f, 20, size[1]/3+50, "Press <Esc> to quit demo", (1,1,1,.7))
putGlyphs(v, f, 20, size[1]/3+100, "Press a key to start", (0,1,0,.7))

try:
    wait(v,timeout=3.0)
except Timeout:
    ggift2.write(v, f, 20, size[1]/3+150, "SO?!", (1,0,0,1))
    wait(v)
    
v.fill()
v.fg  = (1,1,1)
props = [ "file : %s"%sys.argv[1],
          "family : %s, style : %s"%(f.familyName, f.styleName),
          "properties: %s"%', '.join(ft2.getFaceProperties(f)),
          "ascender : %i, decender %i"%(f.ascender, f.descender),
          "bounding box %s"%str(f.bbox) ]

nprops = len(props)
for i in xrange(nprops):
    v.putString(0,i*fy,props[i])
    
origin   = (150,300)
baseline = origin[1]
bbox     = [ origin[0], baseline + f.ascender/64, 20,20 ]

red   = v.map(1,0,0)
blue  = v.map(0,0,1)
white = v.map(1,1,1)

i=0

while(i>=0):

    f.loadGlyph(i,ft2.LOAD_RENDER)
    v.fg = 0
    v.putBox(0, nprops*fy, size[0], size[1])
    v.fg = white
    v.putString(0, nprops*fy, "glyph %i/%i    "%(i+1,f.numGlyphs))
    b = f.bitmap

    # baseline
    v.putHLine(0,baseline,size[1],red)
    
    # bbox
    v.fg = blue
    box(v, origin[0]-1, baseline-b[1]-1, b[2]+2, b[3]+2)

    # glyph
    putGlyph(v, f, origin[0]-b[0], origin[1], (1,1,1,.9))
    e = wait(v)
    if e.label == ord('-') and i != 0:
        i -= 1
    elif e.label==27:
        i = -1
    else:
        i += 1
